"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenCollectiveInstance = exports.TokenRef = void 0;
const anchor_1 = require("@project-serum/anchor");
const spl_token_collective_1 = require("./generated/spl-token-collective");
const tokenCollectiveCoder = new anchor_1.Coder(spl_token_collective_1.SplTokenCollectiveIDLJson);
const TokenRef = (pubkey, account) => {
    const coded = tokenCollectiveCoder.accounts.decode("TokenRefV0", account.data);
    return Object.assign(Object.assign({}, coded), { publicKey: pubkey, isClaimed: coded.isClaimed || !!coded.owner // TODO: Remove this or after beta, there was a bug in the smart contract
     });
};
exports.TokenRef = TokenRef;
const TokenCollectiveInstance = (pubkey, account) => {
    const coded = tokenCollectiveCoder.accounts.decode("CollectiveV0", account.data);
    return Object.assign(Object.assign({}, coded), { publicKey: pubkey });
};
exports.TokenCollectiveInstance = TokenCollectiveInstance;
//# sourceMappingURL=deserializers.js.map